interface

{$IFNDEF FROMPACKAGEONLY}
you must compile this from the package file only since that is setting necessary conditional defines
{$ENDIF}

{$DEFINE ENABLE_GIF}

uses Graphics{$IFDEF USERX}, Controls{$ENDIF};

//function getBitmap(imageFile:string):TBitmap;
function getPicture(imageFile:string):TPicture;
function getBitmap(p:TPicture{$IFDEF USERX}; c:TWinControl{$ENDIF}):TBitmap;
procedure deleteImages(var image:TBitmap; var picture:TPicture);
function generateMaskFromImage(Image:TPicture):TPicture;

function getExtensionFor(picture:TPicture):string;

implementation

uses SysUtils, Jpeg, ExtCtrls, Contnrs, typinfo,
{$IFDEF ENABLE_GIF}
  {$IFDEF USERX}
    Classes, GifCtrl, RXGif, Messages
  {$ELSE}
    GifImage
  {$ENDIF}
  ,
{$ENDIF}
     Types;

{$IFDEF USERX}
var
  helperlist:TObjectList=nil;
{$ENDIF}

function getPicture(imageFile:string):TPicture;
var p:TPicture;
begin
  if not fileexists(imageFile) then
  begin
    result:=nil;
    exit;
  end;
  p:=TPicture.Create;
  p.LoadFromFile(imageFile);
  result:=p;
end;

function generateMaskFromImage(Image:TPicture):TPicture;
var b:TBitmap;
begin
  result:=nil;
  {$IFDEF NONRX}
  if not TGifImage(image.Graphic).IsTransparent then
    exit;
  {$ELSE}
  if not Image.Graphic.Transparent then
    exit;
  {$ENDIF}
  if true
  {$IFDEF ENABLE_GIF}and (not image.Graphic.ClassType.InheritsFrom(TGIFImage)) {$ENDIF}
    then
    exit;
  b:=TBitmap.Create;
  b.Height:=image.Graphic.Height;
  b.Width:=image.Graphic.Width;
{$IFDEF ENABLE_GIF}
  if image.Graphic.ClassType.InheritsFrom(TGIFImage) then
  begin
    {$IFDEF USERX}
    b.assign(TGifImage(image.Graphic).Frames[0].Bitmap);
    b.Mask(TGifImage(image.Graphic).Frames[0].TransparentColor);
    {$ELSE}
    b.assign(TGifImage(image.Graphic).Images[0].Bitmap);
    b.mask(TGifImage(image.Graphic).Images[0].GraphicControlExtension.TransparentColor);
    {$ENDIF}
//    b.SaveToFile('_mask_.bmp');
  end                       else
{$ENDIF}
    raise exception.create('Image type for mask generation not implemented.');
  result:=TPicture.Create;
  result.Bitmap:=b;
end;

{$IFDEF USERX}
type
  TGifHelper=class
  private
    FAnimator:TRxGIFAnimator;
    FBitmap:TBitmap;
    FPicture:TPicture;
//    FHookedWindowProc:TWndMethod;
//    FInternal:boolean;
    procedure DrawFrame(Sender:TObject);
//    procedure MyWndProc(var msg:TMessage);
  public
    constructor Create(APicture:TPicture; ABitmap:TBitmap; AControl:TWinControl);
    destructor Destroy; override;
  end;

function findHelper(p:TPicture):integer;
var i:integer;
begin
  i:=0;
  while ((i<helperlist.count) and (TGifHelper(helperlist[i]).FPicture<>p)) do
    inc(i);
  if i<helperlist.count then
    result:=i
  else
    result:=-1;
end;

{ TGifHelper }

type
  THelperControl=class(TControl)// cannot get the window proc hooks to get along
                                // and pass the needed messages to the below
                                // control so will pass some of the events instead
  end;
  
constructor TGifHelper.Create(APicture:TPicture; ABitmap:TBitmap; AControl:TWinControl);
begin
  FAnimator:=TRxGIFAnimator.Create(AControl);
  FAnimator.parent:=AControl;
  FBitmap:=ABitmap;
  FPicture:=APicture;
  with FAnimator do
  begin
    Loop:=true;
    Transparent:=true;
    AsyncDrawing:=true;
    Image:=TGifImage(APicture.Graphic);
    Animate:=true;
    OnFrameChanged:=DrawFrame;
{    FHookedWindowProc:=WindowProc;
    WindowProc:=MyWndProc;}
    OnClick:=THelperControl(AControl).OnClick;
  end;
end;

destructor TGifHelper.Destroy;
begin
  try
    freeandnil(FAnimator);// might be destroyed by the owner control or when disabling skin 
  except
  end;
  inherited;
end;

procedure TGifHelper.DrawFrame(Sender: TObject);
begin
  // unfortunatly this means that the drawing is done twice, once in the
  // actual gif image, and second time on the needed bitmap canvas.
  // this cannot be overcome due to the fact that rxgifanimator doe snot provide
  // animating on a custom canvas
  fanimator.Image.Frames[fanimator.Image.FrameIndex].Draw(FBitmap.Canvas, FBitmap.Canvas.ClipRect, true);
end;

{procedure TGifHelper.MyWndProc(var msg: TMessage);
begin
  FHookedWindowProc(msg);
  if msg.msg=WM_PAINT then
    exit;
  if (msg.Msg >= WM_MOUSEFIRST) and (msg.Msg <= WM_MOUSELAST)
     or (msg.Msg >= WM_KEYFIRST) and (msg.Msg <= WM_KEYLAST)
      or (msg.msg=CM_VISIBLECHANGED)
    then
      if not FInternal then
      begin
        FInternal:=true;
        msg.result:=0;
        FAnimator.Parent.perform(msg.msg, msg.wparam, msg.lparam);
        FInternal:=false;
      end;
end;}

{$ENDIF}

function getBitmap(p:TPicture{$IFDEF USERX}; c:TWinControl{$ENDIF}):TBitmap;
//var r:TRect;
var b:TBitmap; 
    {$IFDEF USERX}
    h:TGifHelper;
    {$ENDIF}
begin
  if p=nil then
  begin
    result:=nil;
    exit;
  end;
  b:=TBitmap.Create;
{$IFDEF ENABLE_GIF}
  if p.Graphic.ClassType.InheritsFrom(TGIFImage) then
  begin       
    b.Height:=TGifImage(p.Graphic).Height;
    b.Width:=TGifImage(p.Graphic).Width;
    {$IFDEF USERX}
    h:=TGifHelper.Create(p, b, c);
    helperList.add(h);
    {$ELSE}
    TGifImage(p.Graphic).Paint(b.Canvas, b.Canvas.ClipRect,[goAsync,goLoop,goLoopContinously,goAnimate,goDirectDraw,goDither,goAutoDither,goTransparent]);
    {$ENDIF}
  end                       else
{$ENDIF}  
    if p.Graphic is TJPEGImage then b.Assign(TJPEGImage(p.Graphic))
                               else b.Assign(p.Bitmap);
  result:=b;
end;

procedure deleteImages(var image:TBitmap; var picture:TPicture);
{$IFDEF USERX}
var i:integer;
{$ENDIF}
begin
  if picture<>nil then
  begin
{$IFDEF ENABLE_GIF}
    if picture.Graphic is TGIFImage then
    {$IFDEF USERX}
    begin
      i:=findHelper(picture);
      if i>-1 then
        helperlist.delete(i);
    end;
    {$ELSE}
      TGIFImage(picture.Graphic).StopDraw;
    {$ENDIF}
{$ENDIF}      
    picture.Free;
    picture:=nil;
  end;
  if image<>nil then
  begin
    image.Free;
    image:=nil;
  end;
end;

function getExtensionFor(picture:TPicture):string;
begin
  if picture = nil then result:=''
                   else
    if picture.Graphic is TJPEGImage then result:='jpg'
{$IFDEF ENABLE_GIF}
                                     else
      if picture.Graphic is TGIFImage then result:='gif'
{$ENDIF}      
                                      else result:='';
end;

{function isGif(img:string):boolean;
begin
  img:=lowercase(img);
  result:=ExtractFileExt(img)='.gif';
end;

function isJpg(img:string):boolean;
begin
  img:=lowercase(img);
  result:=(ExtractFileExt(img)='.jpg') or (ExtractFileExt(img)='.jpeg');
end;

function getBitmap(imageFile:string):TBitmap;
var i:TBitmap; jpg:TJpegFile; img:TImage;
begin
  i:=TBitmap.Create;
  if isGif(imageFile) then
  begin
  end                 else
    if isJpg(imageFile) then
    begin
      jpg:=TJpegImage.Create;
      jpg.LoadFromFile(imageFile);
      i.Assign(jpg);
      jpg.free;
    end             else
    begin
      img:=TImage.Create(nil);
      img.picture.LoadFromFile(imageFile);
      i.Assign(img.picture.Bitmap);
      img.Free;
    end;
  result:=i;
end;{}

{$IFDEF USERX}
initialization
  helperlist:=TObjectList.Create(true);

finalization

{$ENDIF}

end.